#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	[PluginInfo(Name = "MyFunc1", Category = "Value", Version = "")]
	public class MyFuncNode : IPluginEvaluate
	{
		[Output("Output")]
		ISpread<Func<double, double, bool, double>> FFunc;
		
		public double FuncDoble1(double x, double y , bool Ad)
		{
		 
		    if (Ad)
		    {
		        x = x + y;
		    }
		    if (!Ad)
		    { 
		    var r = new Random();
		    double z = r.NextDouble()-0.5 ;
		        x = x - y + z ;
		    }
		 
		    return x;
		}
		
		public void Evaluate(int SpreadMax)
		{
			FFunc.SliceCount = 1;
			
			//just output the function itself.
			//note that we dont apply the function by feeding inputs.
			//we just output the functionality of that function... 
			FFunc[0] = FuncDoble1;
		}
	}	
}
